diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp.php	2013-01-04 16:52:10.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp.php	2013-03-01 11:51:16.000000000 -0600
***************
*** 25,31 ****
  	 * @since 2.0.0
  	 * @var array
  	 */
! 	var $private_query_vars = array('offset', 'posts_per_page', 'posts_per_archive_page', 'showposts', 'nopaging', 'post_type', 'post_status', 'category__in', 'category__not_in', 'category__and', 'tag__in', 'tag__not_in', 'tag__and', 'tag_slug__in', 'tag_slug__and', 'tag_id', 'post_mime_type', 'perm', 'comments_per_page', 'post__in', 'post__not_in');
  
  	/**
  	 * Extra query variables set by the user.
--- 25,31 ----
  	 * @since 2.0.0
  	 * @var array
  	 */
! 	var $private_query_vars = array( 'offset', 'posts_per_page', 'posts_per_archive_page', 'showposts', 'nopaging', 'post_type', 'post_status', 'category__in', 'category__not_in', 'category__and', 'tag__in', 'tag__not_in', 'tag__and', 'tag_slug__in', 'tag_slug__and', 'tag_id', 'post_mime_type', 'perm', 'comments_per_page', 'post__in', 'post__not_in', 'post_parent__in', 'post_parent__not_in' );
  
  	/**
  	 * Extra query variables set by the user.
***************
*** 356,362 ****
  
  			// Support for Conditional GET
  			if (isset($_SERVER['HTTP_IF_NONE_MATCH']))
! 				$client_etag = stripslashes(stripslashes($_SERVER['HTTP_IF_NONE_MATCH']));
  			else $client_etag = false;
  
  			$client_last_modified = empty($_SERVER['HTTP_IF_MODIFIED_SINCE']) ? '' : trim($_SERVER['HTTP_IF_MODIFIED_SINCE']);
--- 356,362 ----
  
  			// Support for Conditional GET
  			if (isset($_SERVER['HTTP_IF_NONE_MATCH']))
! 				$client_etag = wp_unslash( $_SERVER['HTTP_IF_NONE_MATCH'] );
  			else $client_etag = false;
  
  			$client_last_modified = empty($_SERVER['HTTP_IF_MODIFIED_SINCE']) ? '' : trim($_SERVER['HTTP_IF_MODIFIED_SINCE']);
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class.wp-scripts.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class.wp-scripts.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class.wp-scripts.php	2012-06-28 15:18:38.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class.wp-scripts.php	2013-07-10 00:38:17.000000000 -0500
***************
*** 133,138 ****
--- 133,141 ----
  	 * Localizes only if the script has already been added
  	 */
  	function localize( $handle, $object_name, $l10n ) {
+ 		if ( $handle === 'jquery' )
+ 			$handle = 'jquery-core';
+ 
  		if ( is_array($l10n) && isset($l10n['l10n_print_after']) ) { // back compat, preserve the code in 'l10n_print_after' if present
  			$after = $l10n['l10n_print_after'];
  			unset($l10n['l10n_print_after']);
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class.wp-styles.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class.wp-styles.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class.wp-styles.php	2012-06-28 15:18:38.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class.wp-styles.php	2013-04-22 14:22:09.000000000 -0500
***************
*** 50,56 ****
  				$this->concat .= "$handle,";
  				$this->concat_version .= "$handle$ver";
  
! 				$this->print_code .= $this->get_data( $handle, 'after' );
  
  				return true;
  			}
--- 50,56 ----
  				$this->concat .= "$handle,";
  				$this->concat_version .= "$handle$ver";
  
! 				$this->print_code .= $this->print_inline_style( $handle, false );
  
  				return true;
  			}
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-theme.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-theme.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-theme.php	2012-12-07 03:53:27.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-theme.php	2013-07-08 08:04:07.000000000 -0500
***************
*** 37,47 ****
  	 * @var array
  	 */
  	private static $default_themes = array(
! 		'classic'      => 'WordPress Classic',
! 		'default'      => 'WordPress Default',
! 		'twentyten'    => 'Twenty Ten',
! 		'twentyeleven' => 'Twenty Eleven',
! 		'twentytwelve' => 'Twenty Twelve',
  	);
  
  	/**
--- 37,48 ----
  	 * @var array
  	 */
  	private static $default_themes = array(
! 		'classic'        => 'WordPress Classic',
! 		'default'        => 'WordPress Default',
! 		'twentyten'      => 'Twenty Ten',
! 		'twentyeleven'   => 'Twenty Eleven',
! 		'twentytwelve'   => 'Twenty Twelve',
! 		'twentythirteen' => 'Twenty Thirteen',
  	);
  
  	/**
***************
*** 86,92 ****
  	/**
  	 * The directory name of the theme's files, inside the theme root.
  	 *
! 	 * In the case of a child theme, this is directory name of the the child theme.
  	 * Otherwise, 'stylesheet' is the same as 'template'.
  	 *
  	 * @access private
--- 87,93 ----
  	/**
  	 * The directory name of the theme's files, inside the theme root.
  	 *
! 	 * In the case of a child theme, this is directory name of the child theme.
  	 * Otherwise, 'stylesheet' is the same as 'template'.
  	 *
  	 * @access private
***************
*** 719,725 ****
  	/**
  	 * The directory name of the theme's "stylesheet" files, inside the theme root.
  	 *
! 	 * In the case of a child theme, this is directory name of the the child theme.
  	 * Otherwise, get_stylesheet() is the same as get_template().
  	 *
  	 * @since 3.4.0
--- 720,726 ----
  	/**
  	 * The directory name of the theme's "stylesheet" files, inside the theme root.
  	 *
! 	 * In the case of a child theme, this is directory name of the child theme.
  	 * Otherwise, get_stylesheet() is the same as get_template().
  	 *
  	 * @since 3.4.0
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-walker.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-walker.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-walker.php	2012-10-04 15:00:16.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-walker.php	2013-05-27 22:29:15.000000000 -0500
***************
*** 80,86 ****
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
  	 */
! 	function start_el( &$output, $object, $depth, $args, $current_object_id = 0 )  {}
  
  	/**
  	 * Ends the element output, if needed.
--- 80,86 ----
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
  	 */
! 	function start_el( &$output, $object, $depth = 0, $args = array(), $current_object_id = 0 )  {}
  
  	/**
  	 * Ends the element output, if needed.
***************
*** 115,121 ****
  	 * @param string $output Passed by reference. Used to append additional content.
  	 * @return null Null on failure with no changes to parameters.
  	 */
! 	function display_element( $element, &$children_elements, $max_depth, $depth=0, $args, &$output ) {
  
  		if ( !$element )
  			return;
--- 115,121 ----
  	 * @param string $output Passed by reference. Used to append additional content.
  	 * @return null Null on failure with no changes to parameters.
  	 */
! 	function display_element( $element, &$children_elements, $max_depth, $depth, $args, &$output ) {
  
  		if ( !$element )
  			return;
***************
*** 123,129 ****
  		$id_field = $this->db_fields['id'];
  
  		//display this element
! 		if ( is_array( $args[0] ) )
  			$args[0]['has_children'] = ! empty( $children_elements[$element->$id_field] );
  		$cb_args = array_merge( array(&$output, $element, $depth), $args);
  		call_user_func_array(array($this, 'start_el'), $cb_args);
--- 123,129 ----
  		$id_field = $this->db_fields['id'];
  
  		//display this element
! 		if ( isset( $args[0] ) && is_array( $args[0] ) )
  			$args[0]['has_children'] = ! empty( $children_elements[$element->$id_field] );
  		$cb_args = array_merge( array(&$output, $element, $depth), $args);
  		call_user_func_array(array($this, 'start_el'), $cb_args);
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-xmlrpc-server.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-xmlrpc-server.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-xmlrpc-server.php	2013-06-21 01:12:17.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-xmlrpc-server.php	2013-07-31 01:53:06.000000000 -0500
***************
*** 12,19 ****
   * pingback. Additional WordPress API for managing comments, pages, posts,
   * options, etc.
   *
!  * Since WordPress 2.6.0, WordPress XMLRPC server can be disabled in the
!  * administration panels.
   *
   * @package WordPress
   * @subpackage Publishing
--- 12,19 ----
   * pingback. Additional WordPress API for managing comments, pages, posts,
   * options, etc.
   *
!  * As of WordPress 3.5.0, XML-RPC is enabled by default. It can be disabled
!  * via the xmlrpc_enabled filter found in wp_xmlrpc_server::login().
   *
   * @package WordPress
   * @subpackage Publishing
***************
*** 211,238 ****
  	}
  
  	/**
! 	 * Sanitize string or array of strings for database.
  	 *
  	 * @since 1.5.2
  	 *
! 	 * @param string|array $array Sanitize single string or array of strings.
! 	 * @return string|array Type matches $array and sanitized for the database.
  	 */
! 	function escape(&$array) {
! 		global $wpdb;
! 
! 		if (!is_array($array)) {
! 			return($wpdb->escape($array));
! 		} else {
! 			foreach ( (array) $array as $k => $v ) {
! 				if ( is_array($v) ) {
! 					$this->escape($array[$k]);
! 				} else if ( is_object($v) ) {
! 					//skip
! 				} else {
! 					$array[$k] = $wpdb->escape($v);
! 				}
! 			}
  		}
  	}
  
--- 211,232 ----
  	}
  
  	/**
! 	 * Escape string or array of strings for database.
  	 *
  	 * @since 1.5.2
  	 *
! 	 * @param string|array $data Escape single string or array of strings.
! 	 * @return string|array Type matches $data and sanitized for the database.
  	 */
! 	function escape( &$data ) {
! 		if ( ! is_array( $data ) )
! 			return wp_slash( $data );
! 
! 		foreach ( $data as &$v ) {
! 			if ( is_array( $v ) )
! 				$this->escape( $v );
! 			elseif ( ! is_object( $v ) )
! 				$v = wp_slash( $v );
  		}
  	}
  
***************
*** 280,295 ****
  				$meta['id'] = (int) $meta['id'];
  				$pmeta = get_metadata_by_mid( 'post', $meta['id'] );
  				if ( isset($meta['key']) ) {
! 					$meta['key'] = stripslashes( $meta['key'] );
! 					if ( $meta['key'] != $pmeta->meta_key )
  						continue;
! 					$meta['value'] = stripslashes_deep( $meta['value'] );
  					if ( current_user_can( 'edit_post_meta', $post_id, $meta['key'] ) )
  						update_metadata_by_mid( 'post', $meta['id'], $meta['value'] );
  				} elseif ( current_user_can( 'delete_post_meta', $post_id, $pmeta->meta_key ) ) {
  					delete_metadata_by_mid( 'post', $meta['id'] );
  				}
! 			} elseif ( current_user_can( 'add_post_meta', $post_id, stripslashes( $meta['key'] ) ) ) {
  				add_post_meta( $post_id, $meta['key'], $meta['value'] );
  			}
  		}
--- 274,289 ----
  				$meta['id'] = (int) $meta['id'];
  				$pmeta = get_metadata_by_mid( 'post', $meta['id'] );
  				if ( isset($meta['key']) ) {
! 					$meta['key'] = wp_unslash( $meta['key'] );
! 					if ( $meta['key'] !== $pmeta->meta_key )
  						continue;
! 					$meta['value'] = wp_unslash( $meta['value'] );
  					if ( current_user_can( 'edit_post_meta', $post_id, $meta['key'] ) )
  						update_metadata_by_mid( 'post', $meta['id'], $meta['value'] );
  				} elseif ( current_user_can( 'delete_post_meta', $post_id, $pmeta->meta_key ) ) {
  					delete_metadata_by_mid( 'post', $meta['id'] );
  				}
! 			} elseif ( current_user_can( 'add_post_meta', $post_id, wp_unslash( $meta['key'] ) ) ) {
  				add_post_meta( $post_id, $meta['key'], $meta['value'] );
  			}
  		}
***************
*** 318,332 ****
  				'value'         => $wp_version
  			),
  			'blog_url'          => array(
! 				'desc'          => __( 'Site URL' ),
  				'readonly'      => true,
  				'option'        => 'siteurl'
  			),
  			'home_url'          => array(
! 				'desc'          => __( 'Home URL' ),
  				'readonly'      => true,
  				'option'        => 'home'
  			),
  			'image_default_link_type' => array(
  				'desc'          => __( 'Image default link type' ),
  				'readonly'      => true,
--- 312,336 ----
  				'value'         => $wp_version
  			),
  			'blog_url'          => array(
! 				'desc'          => __( 'WordPress Address (URL)' ),
  				'readonly'      => true,
  				'option'        => 'siteurl'
  			),
  			'home_url'          => array(
! 				'desc'          => __( 'Site Address (URL)' ),
  				'readonly'      => true,
  				'option'        => 'home'
  			),
+ 			'login_url'          => array(
+ 				'desc'          => __( 'Login Address (URL)' ),
+ 				'readonly'      => true,
+ 				'value'         => wp_login_url( )
+ 			),
+ 			'admin_url'          => array(
+ 				'desc'          => __( 'The URL to the admin area' ),
+ 				'readonly'      => true,
+ 				'value'         => get_admin_url( )
+ 			),
  			'image_default_link_type' => array(
  				'desc'          => __( 'Image default link type' ),
  				'readonly'      => true,
***************
*** 562,574 ****
  		if ( ! is_array( $_term) )
  			$_term = get_object_vars( $_term );
  
! 		// For Intergers which may be largeer than XMLRPC supports ensure we return strings.
  		$_term['term_id'] = strval( $_term['term_id'] );
  		$_term['term_group'] = strval( $_term['term_group'] );
  		$_term['term_taxonomy_id'] = strval( $_term['term_taxonomy_id'] );
  		$_term['parent'] = strval( $_term['parent'] );
  
! 		// Count we are happy to return as an Integer because people really shouldn't use Terms that much.
  		$_term['count'] = intval( $_term['count'] );
  
  		return apply_filters( 'xmlrpc_prepare_term', $_term, $term );
--- 566,578 ----
  		if ( ! is_array( $_term) )
  			$_term = get_object_vars( $_term );
  
! 		// For integers which may be larger than XML-RPC supports ensure we return strings.
  		$_term['term_id'] = strval( $_term['term_id'] );
  		$_term['term_group'] = strval( $_term['term_group'] );
  		$_term['term_taxonomy_id'] = strval( $_term['term_taxonomy_id'] );
  		$_term['parent'] = strval( $_term['parent'] );
  
! 		// Count we are happy to return as an integer because people really shouldn't use terms that much.
  		$_term['count'] = intval( $_term['count'] );
  
  		return apply_filters( 'xmlrpc_prepare_term', $_term, $term );
***************
*** 1007,1013 ****
  		if ( $update ) {
  			if ( ! get_post( $post_data['ID'] ) )
  				return new IXR_Error( 401, __( 'Invalid post ID.' ) );
! 			if ( ! current_user_can( $post_type->cap->edit_post, $post_data['ID'] ) )
  				return new IXR_Error( 401, __( 'Sorry, you are not allowed to edit this post.' ) );
  			if ( $post_data['post_type'] != get_post_type( $post_data['ID'] ) )
  				return new IXR_Error( 401, __( 'The post type may not be changed.' ) );
--- 1011,1017 ----
  		if ( $update ) {
  			if ( ! get_post( $post_data['ID'] ) )
  				return new IXR_Error( 401, __( 'Invalid post ID.' ) );
! 			if ( ! current_user_can( 'edit_post', $post_data['ID'] ) )
  				return new IXR_Error( 401, __( 'Sorry, you are not allowed to edit this post.' ) );
  			if ( $post_data['post_type'] != get_post_type( $post_data['ID'] ) )
  				return new IXR_Error( 401, __( 'The post type may not be changed.' ) );
***************
*** 1317,1324 ****
  		if ( empty( $post['ID'] ) )
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
! 		$post_type = get_post_type_object( $post['post_type'] );
! 		if ( ! current_user_can( $post_type->cap->delete_post, $post_id ) )
  			return new IXR_Error( 401, __( 'Sorry, you are not allowed to delete this post.' ) );
  
  		$result = wp_delete_post( $post_id );
--- 1321,1327 ----
  		if ( empty( $post['ID'] ) )
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
! 		if ( ! current_user_can( 'delete_post', $post_id ) )
  			return new IXR_Error( 401, __( 'Sorry, you are not allowed to delete this post.' ) );
  
  		$result = wp_delete_post( $post_id );
***************
*** 1399,1406 ****
  		if ( empty( $post['ID'] ) )
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
! 		$post_type = get_post_type_object( $post['post_type'] );
! 		if ( ! current_user_can( $post_type->cap->edit_post, $post_id ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		return $this->_prepare_post( $post, $fields );
--- 1402,1408 ----
  		if ( empty( $post['ID'] ) )
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
! 		if ( ! current_user_can( 'edit_post', $post_id ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		return $this->_prepare_post( $post, $fields );
***************
*** 1495,1502 ****
  		$struct = array();
  
  		foreach ( $posts_list as $post ) {
! 			$post_type = get_post_type_object( $post['post_type'] );
! 			if ( ! current_user_can( $post_type->cap->edit_post, $post['ID'] ) )
  				continue;
  
  			$struct[] = $this->_prepare_post( $post, $fields );
--- 1497,1503 ----
  		$struct = array();
  
  		foreach ( $posts_list as $post ) {
! 			if ( ! current_user_can( 'edit_post', $post['ID'] ) )
  				continue;
  
  			$struct[] = $this->_prepare_post( $post, $fields );
***************
*** 2978,2986 ****
  		$comment['comment_post_ID'] = $post_id;
  
  		if ( $logged_in ) {
! 			$comment['comment_author'] = $wpdb->escape( $user->display_name );
! 			$comment['comment_author_email'] = $wpdb->escape( $user->user_email );
! 			$comment['comment_author_url'] = $wpdb->escape( $user->user_url );
  			$comment['user_ID'] = $user->ID;
  		} else {
  			$comment['comment_author'] = '';
--- 2979,2987 ----
  		$comment['comment_post_ID'] = $post_id;
  
  		if ( $logged_in ) {
! 			$comment['comment_author'] = $this->escape( $user->display_name );
! 			$comment['comment_author_email'] = $this->escape( $user->user_email );
! 			$comment['comment_author_url'] = $this->escape( $user->user_url );
  			$comment['user_ID'] = $user->ID;
  		} else {
  			$comment['comment_author'] = '';
***************
*** 3192,3197 ****
--- 3193,3199 ----
  	 */
  	function _getOptions($options) {
  		$data = array();
+ 		$can_manage = current_user_can( 'manage_options' );
  		foreach ( $options as $option ) {
  			if ( array_key_exists( $option, $this->blog_options ) ) {
  				$data[$option] = $this->blog_options[$option];
***************
*** 3200,3205 ****
--- 3202,3210 ----
  					$data[$option]['value'] = get_option( $data[$option]['option'] );
  					unset($data[$option]['option']);
  				}
+ 
+ 				if ( ! $can_manage )
+ 					$data[$option]['readonly'] = true;
  			}
  		}
  
***************
*** 3535,3541 ****
  			return new IXR_Error( 401, __( 'Sorry, you are not allowed to edit posts.' ) );
  
  		// Check if revisions are enabled.
! 		if ( ! WP_POST_REVISIONS || ! post_type_supports( $post->post_type, 'revisions' ) )
  			return new IXR_Error( 401, __( 'Sorry, revisions are disabled.' ) );
  
  		$revisions = wp_get_post_revisions( $post_id );
--- 3540,3546 ----
  			return new IXR_Error( 401, __( 'Sorry, you are not allowed to edit posts.' ) );
  
  		// Check if revisions are enabled.
! 		if ( ! wp_revisions_enabled( $post ) )
  			return new IXR_Error( 401, __( 'Sorry, revisions are disabled.' ) );
  
  		$revisions = wp_get_post_revisions( $post_id );
***************
*** 3602,3608 ****
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		// Check if revisions are disabled.
! 		if ( ! WP_POST_REVISIONS || ! post_type_supports( $post->post_type, 'revisions' ) )
  			return new IXR_Error( 401, __( 'Sorry, revisions are disabled.' ) );
  
  		$post = wp_restore_post_revision( $revision_id );
--- 3607,3613 ----
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		// Check if revisions are disabled.
! 		if ( ! wp_revisions_enabled( $post ) )
  			return new IXR_Error( 401, __( 'Sorry, revisions are disabled.' ) );
  
  		$post = wp_restore_post_revision( $revision_id );
***************
*** 3746,3754 ****
  
  		$categories = implode(',', wp_get_post_categories($post_ID));
  
! 		$content  = '<title>'.stripslashes($post_data['post_title']).'</title>';
  		$content .= '<category>'.$categories.'</category>';
! 		$content .= stripslashes($post_data['post_content']);
  
  		$struct = array(
  			'userid'    => $post_data['post_author'],
--- 3751,3759 ----
  
  		$categories = implode(',', wp_get_post_categories($post_ID));
  
! 		$content  = '<title>'.wp_unslash($post_data['post_title']).'</title>';
  		$content .= '<category>'.$categories.'</category>';
! 		$content .= wp_unslash($post_data['post_content']);
  
  		$struct = array(
  			'userid'    => $post_data['post_author'],
***************
*** 3784,3789 ****
--- 3789,3797 ----
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
+ 		if ( ! current_user_can( 'edit_posts' ) )
+ 			return new IXR_Error( 401, __( 'Sorry, you cannot edit posts on this site.' ) );
+ 
  		do_action('xmlrpc_call', 'blogger.getRecentPosts');
  
  		$posts_list = wp_get_recent_posts( $query );
***************
*** 3800,3808 ****
  			$post_date  = $this->_convert_date( $entry['post_date'] );
  			$categories = implode(',', wp_get_post_categories($entry['ID']));
  
! 			$content  = '<title>'.stripslashes($entry['post_title']).'</title>';
  			$content .= '<category>'.$categories.'</category>';
! 			$content .= stripslashes($entry['post_content']);
  
  			$struct[] = array(
  				'userid' => $entry['post_author'],
--- 3808,3816 ----
  			$post_date  = $this->_convert_date( $entry['post_date'] );
  			$categories = implode(',', wp_get_post_categories($entry['ID']));
  
! 			$content  = '<title>'.wp_unslash($entry['post_title']).'</title>';
  			$content .= '<category>'.$categories.'</category>';
! 			$content .= wp_unslash($entry['post_content']);
  
  			$struct[] = array(
  				'userid' => $entry['post_author'],
***************
*** 4300,4321 ****
  		return strval($post_ID);
  	}
  
! 	function add_enclosure_if_new($post_ID, $enclosure) {
  		if ( is_array( $enclosure ) && isset( $enclosure['url'] ) && isset( $enclosure['length'] ) && isset( $enclosure['type'] ) ) {
! 
! 			$encstring = $enclosure['url'] . "\n" . $enclosure['length'] . "\n" . $enclosure['type'];
  			$found = false;
! 			foreach ( (array) get_post_custom($post_ID) as $key => $val) {
! 				if ($key == 'enclosure') {
! 					foreach ( (array) $val as $enc ) {
! 						if ($enc == $encstring) {
! 							$found = true;
! 							break 2;
! 						}
  					}
  				}
  			}
! 			if (!$found)
  				add_post_meta( $post_ID, 'enclosure', $encstring );
  		}
  	}
--- 4308,4327 ----
  		return strval($post_ID);
  	}
  
! 	function add_enclosure_if_new( $post_ID, $enclosure ) {
  		if ( is_array( $enclosure ) && isset( $enclosure['url'] ) && isset( $enclosure['length'] ) && isset( $enclosure['type'] ) ) {
! 			$encstring = $enclosure['url'] . "\n" . $enclosure['length'] . "\n" . $enclosure['type'] . "\n";
  			$found = false;
! 			if ( $enclosures = get_post_meta( $post_ID, 'enclosure' ) ) {
! 				foreach ( $enclosures as $enc ) {
! 					// This method used to omit the trailing new line. #23219
! 					if ( rtrim( $enc, "\n" ) == rtrim( $encstring, "\n" ) ) {
! 						$found = true;
! 						break;
  					}
  				}
  			}
! 			if ( ! $found )
  				add_post_meta( $post_ID, 'enclosure', $encstring );
  		}
  	}
***************
*** 4335,4341 ****
  		$attachments = $wpdb->get_results( "SELECT ID, guid FROM {$wpdb->posts} WHERE post_parent = '0' AND post_type = 'attachment'" );
  		if ( is_array( $attachments ) ) {
  			foreach ( $attachments as $file ) {
! 				if ( strpos( $post_content, $file->guid ) !== false )
  					$wpdb->update($wpdb->posts, array('post_parent' => $post_ID), array('ID' => $file->ID) );
  			}
  		}
--- 4341,4347 ----
  		$attachments = $wpdb->get_results( "SELECT ID, guid FROM {$wpdb->posts} WHERE post_parent = '0' AND post_type = 'attachment'" );
  		if ( is_array( $attachments ) ) {
  			foreach ( $attachments as $file ) {
! 				if ( ! empty( $file->guid ) && strpos( $post_content, $file->guid ) !== false )
  					$wpdb->update($wpdb->posts, array('post_parent' => $post_ID), array('ID' => $file->ID) );
  			}
  		}
***************
*** 4757,4762 ****
--- 4763,4771 ----
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
+ 		if ( ! current_user_can( 'edit_posts' ) )
+ 			return new IXR_Error( 401, __( 'Sorry, you cannot edit posts on this site.' ) );
+ 
  		do_action('xmlrpc_call', 'metaWeblog.getRecentPosts');
  
  		$posts_list = wp_get_recent_posts( $query );
***************
*** 4908,4915 ****
  		global $wpdb;
  
  		$blog_ID     = (int) $args[0];
! 		$username  = $wpdb->escape($args[1]);
! 		$password   = $wpdb->escape($args[2]);
  		$data        = $args[3];
  
  		$name = sanitize_file_name( $data['name'] );
--- 4917,4924 ----
  		global $wpdb;
  
  		$blog_ID     = (int) $args[0];
! 		$username  = $this->escape($args[1]);
! 		$password   = $this->escape($args[2]);
  		$data        = $args[3];
  
  		$name = sanitize_file_name( $data['name'] );
***************
*** 5380,5386 ****
  		sleep(1);
  
  		// Let's check the remote site
! 		$linea = wp_remote_retrieve_body( wp_remote_get( $pagelinkedfrom, array( 'timeout' => 10, 'redirection' => 0, 'reject_unsafe_urls' => true ) ) );
  
  		if ( !$linea )
  	  		return $this->pingback_error( 16, __( 'The source URL does not exist.' ) );
--- 5389,5400 ----
  		sleep(1);
  
  		// Let's check the remote site
! 		$http_api_args = array(
! 			'timeout' => 10,
! 			'redirection' => 0,
! 			'limit_response_size' => 153600, // 150 KB
! 		);
! 		$linea = wp_remote_retrieve_body( wp_safe_remote_get( $pagelinkedfrom, $http_api_args ) );
  
  		if ( !$linea )
  	  		return $this->pingback_error( 16, __( 'The source URL does not exist.' ) );
***************
*** 5389,5395 ****
  
  		// Work around bug in strip_tags():
  		$linea = str_replace('<!DOC', '<DOC', $linea);
! 		$linea = preg_replace( '/[\s\r\n\t]+/', ' ', $linea ); // normalize spaces
  		$linea = preg_replace( "/<\/*(h1|h2|h3|h4|h5|h6|p|th|td|li|dt|dd|pre|caption|input|textarea|button|body)[^>]*>/", "\n\n", $linea );
  
  		preg_match('|<title>([^<]*?)</title>|is', $linea, $matchtitle);
--- 5403,5409 ----
  
  		// Work around bug in strip_tags():
  		$linea = str_replace('<!DOC', '<DOC', $linea);
! 		$linea = preg_replace( '/[\r\n\t ]+/', ' ', $linea ); // normalize spaces
  		$linea = preg_replace( "/<\/*(h1|h2|h3|h4|h5|h6|p|th|td|li|dt|dd|pre|caption|input|textarea|button|body)[^>]*>/", "\n\n", $linea );
  
  		preg_match('|<title>([^<]*?)</title>|is', $linea, $matchtitle);
***************
*** 5417,5423 ****
  
  				// prevent really long link text
  				if ( strlen($context[1]) > 100 )
! 					$context[1] = substr($context[1], 0, 100) . '...';
  
  				$marker = '<wpcontext>'.$context[1].'</wpcontext>';    // set up our marker
  				$excerpt= str_replace($context[0], $marker, $excerpt); // swap out the link for our marker
--- 5431,5437 ----
  
  				// prevent really long link text
  				if ( strlen($context[1]) > 100 )
! 					$context[1] = substr($context[1], 0, 100) . '&#8230;';
  
  				$marker = '<wpcontext>'.$context[1].'</wpcontext>';    // set up our marker
  				$excerpt= str_replace($context[0], $marker, $excerpt); // swap out the link for our marker
***************
*** 5435,5442 ****
  
  		$pagelinkedfrom = str_replace('&', '&amp;', $pagelinkedfrom);
  
! 		$context = '[...] ' . esc_html( $excerpt ) . ' [...]';
! 		$pagelinkedfrom = $wpdb->escape( $pagelinkedfrom );
  
  		$comment_post_ID = (int) $post_ID;
  		$comment_author = $title;
--- 5449,5456 ----
  
  		$pagelinkedfrom = str_replace('&', '&amp;', $pagelinkedfrom);
  
! 		$context = '[&#8230;] ' . esc_html( $excerpt ) . ' [&#8230;]';
! 		$pagelinkedfrom = $this->escape( $pagelinkedfrom );
  
  		$comment_post_ID = (int) $post_ID;
  		$comment_author = $title;
